import os
import json
import logging as log
from logging.handlers import TimedRotatingFileHandler


directory = os.path.join(os.path.dirname(__file__), "..")
config_file = os.path.join(directory, "config.json")
conf = dict()
if os.path.isfile(config_file):
	with open(config_file) as f: conf = json.load(f)

log_file = conf.get("logFile", "/var/log/morevna/mor.log")

logger = log.getLogger()
logger.setLevel(log.INFO)
formatter = log.Formatter("%(asctime)s %(levelname)s: %(message)s",datefmt="%Y-%m-%d %H:%M:%S")
handler = TimedRotatingFileHandler(log_file, when="midnight", backupCount=9)
handler.setFormatter(formatter)
logger.addHandler(handler)

certfile = os.path.join(directory,"certs/cert.pem")
keyfile = os.path.join(directory,"certs/key.pem")
peers = os.path.join(directory,"certs/peers.pem")

version = [0, 1, 1]
lowest_compatible = [0, 1, 0] # tuple is more fitting but json conversion transforms it into a list anyway

hosts = conf.get("hosts", ["127.0.0.1"])
port = conf.get("port", 9901)

bSize = conf.get("batch_size", dict())
class batch_size:
	hash = bSize.get("hash", 16384)
	data = bSize.get("data", 64)
